/*
    Class CObjReference
    Description: class for storing all object references, to be used with
    CSceneGraph.
*/

#ifndef __CLASS_OBJREFERENCE__
#define __CLASS_OBJREFERENCE__

#include "objfile.h"

class CObjReference
{
protected:
    unsigned int NumOfObject;           // Indicates number of object in list
    Object3D *ObjectList;               // Actual pointer to the list
public:
    CObjReference();			// Default constructor
    CObjReference(const char *path);    // Construct from files in path
    ~CObjReference();                   // Destructor
    unsigned int OpenLibrary(const char *path);	// Open library in path
    int ReferObjectAt(unsigned int index, Object3D *object); // Refer to list
    unsigned int NumberOfObjects(void);  // Returns number of objects
};

#endif
