#include<unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<strings.h>
#include<cave_ogl.h>
#include<GL/gl.h>

#include"MotionData.h"

MotionData::MotionData()
{
	nav_translation[0] = 0.0f;
	nav_translation[1] = 0.0f;
	nav_translation[2] = 0.0f;
	distance = 0.012;
	checkhand = 0;
	anglehand = 0;
}
	
	

MotionData::~MotionData()
{

}

float MotionData::SetData()
{
	return 0;
}

float MotionData::GetData()
{
	return 0;
}

void MotionData::GetNavTranslation(float trans[3])
{
	trans[0] = nav_translation[0];
	trans[1] = nav_translation[1];
	trans[2] = nav_translation[2];
}

void MotionData::GetPrint(){
	printf("nav_translation[0] = %f nav_translation[2] = %f\n",nav_translation[0],nav_translation[2]);
}

void MotionData::DoTransform(void)
{
  
 //algorithm 2   can control walking speed . and can walk varied way . use threshold

  float numerator,denominator,triangleVec;
  float sen6[3],sen5[3],sen6World[3],sen5World[3];
  CAVEGetSensorPosition(CAVESENSOR(6),CAVE_TRACKER_FRAME,sen6);
  CAVEGetSensorPosition(CAVESENSOR(5),CAVE_TRACKER_FRAME,sen5);
  CAVENavConvertCAVEToWorld(sen6, sen6World);
  CAVENavConvertCAVEToWorld(sen5, sen5World);


  numerator = (sen5World[2]) - (sen6World[2]);
  denominator = (sen5World[0]) - (sen6World[0]);
  triangleVec = sqrt((numerator*numerator) + (denominator*denominator));

#ifdef _DEBUG_
  printf("sen6 x = %f y = %f\n",sen6[0],sen6[2]);
  printf("sen5 x = %f y = %f\n",sen5[0],sen5[2]);
  printf("numerator = %f\n", numerator);
  printf("denominator = %f\n", denominator);
  printf("triangleVec = %f\n", triangleVec);
  printf("X orientation = %f\n", numerator/ (triangleVec / distance)); 
  printf("Y orientation = %f\n", denominator/ (triangleVec / distance));
#endif

  float sen2[3],sen3[3];
  CAVEGetSensorPosition(CAVESENSOR(2),CAVE_TRACKER_FRAME,sen2);
  CAVEGetSensorPosition(CAVESENSOR(3),CAVE_TRACKER_FRAME,sen3);

  // Get t0 and t1   to calculate Pitch
  static float t0,t1;
  static int cnt,ocnt;
  ocnt = cnt;

  if ( sen2[1] >= footHight || sen3[1] >= footHight ){
    cnt = 1;
    if(ocnt != cnt){
      t0 = CAVEGetTime();
      //---------From stop    to walk first step-------------
      if(t0 - t1 > 1) distance = 0.012;
      printf("t0 %f \n",t0);
    }
  }else{
    cnt = 0;
    if(ocnt != cnt){
      t1 = CAVEGetTime();
      printf("t1 %f \n",t1);
      // Speed V  = StepLength * Pitch
      distance =StepLength * ( 1/(t1 - t0));
      printf("distance  %f \n",distance);
    }
  }

  float x , y;
  x = numerator / (triangleVec / distance);
  y = denominator / (triangleVec / distance);

/*******************REGION **********************************/
#define SQR(x) ((x)*(x))
#define region 1
float sen7[3];
CAVEGetSensorPosition(CAVESENSOR(7),CAVE_TRACKER_FRAME,sen7);
float 	dist; 
dist = SQR(sen7[0]) + SQR(sen7[2]);
/************************************************************/
	
if( dist < SQR(region))
{
  if ( sen2[1] >= footHight || sen3[1] >= footHight ){
    printf("sen2 = %f sen3 = %f \n",sen2[1],sen3[1]);

	 nav_translation[0] -= x ;
	 nav_translation[2] += y ;

    //CAVENavTranslate( x ,0.0, -y);
    //CAVENavTranslate( 0.0,0.0,-(distance) );
  }
}

/******************FILE OUT*************************************/
        //Estimate
        float time;
        time = CAVEGetTime();

      FILE *fp_out_t;
        if((fp_out_t = fopen ("./DATA/time.txt","a")) == NULL)
                printf("output file can:t open \n");
        else{
                fprintf(fp_out_t,"%f\n",time);
        }
        fclose(fp_out_t);

//        float sen7[3];
        float sen7WorldPos[3];
 //       CAVEGetSensorPosition(CAVESENSOR(7),CAVE_TRACKER_FRAME,sen7);
        CAVENavConvertCAVEToWorld(sen7, sen7WorldPos);

        FILE *fp_out_sx;
        if((fp_out_sx = fopen ("./DATA/senx.txt","a")) == NULL)
                printf("output file can:t open \n");
        else{
                fprintf(fp_out_sx,"%f\n",sen7WorldPos[0]);
        }
        fclose(fp_out_sx);

        FILE *fp_out_sz;
        if((fp_out_sz = fopen ("./DATA/senz.txt","a")) == NULL)
                printf("output file can:t open \n");
        else{
                fprintf(fp_out_sz,"%f\n",sen7WorldPos[2]);
        }
        fclose(fp_out_sz);


   /* SPEED */
        FILE *fp_out_s;
        if((fp_out_s = fopen ("./DATA/Speed.txt","a")) == NULL)
                printf("output file can:t open \n");
        else{
                fprintf(fp_out_s,"%f\n",distance);
        }
        fclose(fp_out_s);

}

